module UartRX(
	input osc_clk,
	input RX,
	output reg [7:0]data,
	output reg isBusy);
	
	reg [7:0]buffer;
	reg [7:0]state = 0; 
	reg [7:0]index = 0; 

	wire tmrRX;

	always @(posedge tmrRX )
	begin
		if(state == 0 && RX == 1'b0)
		begin
			state = state + 1;
		end
		else if(state > 0)
		begin
			state = state + 1;
			
			if(state % 8 == 0)
			begin
				buffer[index - 1] = RX;
				
				index = index + 1;
				
				if(index >= 10)
				begin
					data = buffer;
					index = 0;
					state = 0;
				end
			end
		end
		
		isBusy = state > 0;
	end

	TimeRX timeRX1(osc_clk,tmrRX);
	
endmodule