module PWM(
	input osc_clk,
	input [15:0] val,
	output pwm);
	
	reg [15:0]cnt = 0;
	
	wire clkUs;
	
	assign pwm = (cnt < val);
	
	always @(posedge clkUs)
	begin
		 cnt = cnt + 1;
		 
		 if(cnt > 20000)
			 cnt = 0;
	end
	
	Mikrosecond mikrosecond1(osc_clk, clkUs);
endmodule